<template>
  <div class="container extended pt-5 pb-5">
    <div v-if="canCreate" class="text-right mb-4">
      <b-button @click="onNew()" variant="info">
        <font-awesome-icon :icon="['fas', 'plus']" /> new entry
      </b-button>
    </div>

    <NewsEntry
      v-for="newsEntry in news.content"
      :key="newsEntry.id"
      :news-entry="newsEntry"
      :languages="languages"
      @edit-entry="onEdit"
      @delete-entry="onDelete"
      @publish-entry="onPublish"
      @unpublish-entry="onUnpublish"
    >
    </NewsEntry>

    <div class="mt-4 d-flex justify-content-end">
      <b-pagination
        v-model="currentPage"
        :total-rows="news.totalElements"
        :per-page="pageSize"
        @change="changePage"
      ></b-pagination>
    </div>

    <NewsEditModal
      ref="theModal"
      :languages="languages"
      @save="onSave"
    ></NewsEditModal>
  </div>
</template>

<script>
import NewsEditModal from '~/components/admin/news/NewsEditModal';
import NewsEntry from '~/components/admin/news/NewsEntry';
import AuthorizedMixin from '~/components/security/AuthorizedMixin';
export default {
  layout: 'admin',
  roles: ['ROLE_EDITOR_NEWS', 'ROLE_SYSOP', 'ROLE_TRANSLATOR'],
  components: {
    NewsEntry,
    NewsEditModal,
  },
  mixins: [AuthorizedMixin],
  data() {
    return {
      languages: ['en', 'de', 'fr', 'es', 'ru'],
      news: { totalElements: 0, content: [] },
      currentPage: 1,
      pageSize: 20,
    };
  },
  computed: {
    canCreate() {
      return this.isAuthorized(['NEWS_CREATE']);
    },
  },
  mounted() {
    this.refreshData();
  },
  methods: {
    changePage(page) {
      this.currentPage = page;

      this.refreshData();
    },
    refreshData() {
      this._loadData();
    },
    async _loadData() {
      const loader = this.$loading.show();

      const result = await this.$axios.$get(
        `/admin/news?pageNumber=${this.currentPage - 1}&pageSize=${
          this.pageSize
        }`
      );

      this.news = result;

      loader.hide();
    },
    onDelete(entry) {
      if (!this.isAuthorized(['NEWS_DELETE'])) {
        return;
      }

      this.$bvModal
        .msgBoxConfirm('Are you sure?')
        .then((value) => {
          if (value === true) {
            this._deleteEntry(entry);
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    async _deleteEntry(entry) {
      if (!this.isAuthorized(['NEWS_DELETE'])) {
        return;
      }

      const loader = this.$loading.show();

      await this.$axios.$delete(`/admin/news/${entry.id}`);

      loader.hide();

      this.refreshData();
    },
    onSave(entry, form) {
      let request = JSON.parse(JSON.stringify(form));

      this.$refs.theModal.hide();

      if (entry) {
        if (
          !this.isAuthorized(['NEWS_EDIT']) &&
          this.isAuthorized(['NEWS_TRANSLATE'])
        ) {
          const tmp = request;

          request = JSON.parse(JSON.stringify(entry));

          request.title = tmp.title;
        }

        this._saveEntry(request);
      } else {
        this._createEntry(request);
      }
    },
    onEdit(entry) {
      this.$refs.theModal.show(entry);
    },
    onNew() {
      this.$refs.theModal.show();
    },
    onPublish(entry) {
      if (!this.isAuthorized(['NEWS_PUBLISH'])) {
        return;
      }

      entry.published = true;

      this._saveEntry(entry);
    },
    onUnpublish(entry) {
      if (!this.isAuthorized(['NEWS_PUBLISH'])) {
        return;
      }

      this.$bvModal
        .msgBoxConfirm('Are you sure?')
        .then((value) => {
          if (value === true) {
            this._unpublish(entry);
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    _unpublish(entry) {
      if (!this.isAuthorized(['NEWS_PUBLISH'])) {
        return;
      }

      entry.published = false;

      this._saveEntry(entry);
    },
    async _saveEntry(entry) {
      const loader = this.$loading.show();

      await this.$axios.$put(`/admin/news/${entry.id}`, entry);

      loader.hide();

      this.refreshData();
    },
    async _createEntry(entry) {
      if (!this.isAuthorized(['NEWS_CREATE'])) {
        return;
      }

      const loader = this.$loading.show();

      await this.$axios.$post(`/admin/news`, entry);

      loader.hide();

      this.refreshData();
    },
  },
};
</script>
